/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the TemplateConnectorFormAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TemplateConnectorFormAllOf{}

// TemplateConnectorFormAllOf struct for TemplateConnectorFormAllOf
type TemplateConnectorFormAllOf struct {
	// Label of the source
	Label *string `json:"label,omitempty"`
	// URL of the request
	Url *string `json:"url,omitempty"`
	// HTTP Method of the request
	Method *string `json:"method,omitempty"`
	// HTTP Headers of the request
	Headers []interface{} `json:"headers,omitempty"`
	// HTTP Body of the request
	Body *string `json:"body,omitempty"`
	// Tranformation pipeline of the request
	Transformation *string `json:"transformation,omitempty"`
	// Emitter pipeline of the request
	Emitter *string `json:"emitter,omitempty"`
	// Authorizer ID
	OAuthId *string `json:"oAuthId,omitempty"`
	// Custom params replacing placeholders in the request
	Parameters []string `json:"parameters,omitempty"`
	// Final selections of the attributes to be included in the source
	Attributes []string `json:"attributes,omitempty"`
}

// NewTemplateConnectorFormAllOf instantiates a new TemplateConnectorFormAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTemplateConnectorFormAllOf() *TemplateConnectorFormAllOf {
	this := TemplateConnectorFormAllOf{}
	return &this
}

// NewTemplateConnectorFormAllOfWithDefaults instantiates a new TemplateConnectorFormAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTemplateConnectorFormAllOfWithDefaults() *TemplateConnectorFormAllOf {
	this := TemplateConnectorFormAllOf{}
	return &this
}

// GetLabel returns the Label field value if set, zero value otherwise.
func (o *TemplateConnectorFormAllOf) GetLabel() string {
	if o == nil || IsNil(o.Label) {
		var ret string
		return ret
	}
	return *o.Label
}

// GetLabelOk returns a tuple with the Label field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateConnectorFormAllOf) GetLabelOk() (*string, bool) {
	if o == nil || IsNil(o.Label) {
		return nil, false
	}
	return o.Label, true
}

// HasLabel returns a boolean if a field has been set.
func (o *TemplateConnectorFormAllOf) HasLabel() bool {
	if o != nil && !IsNil(o.Label) {
		return true
	}

	return false
}

// SetLabel gets a reference to the given string and assigns it to the Label field.
func (o *TemplateConnectorFormAllOf) SetLabel(v string) {
	o.Label = &v
}

// GetUrl returns the Url field value if set, zero value otherwise.
func (o *TemplateConnectorFormAllOf) GetUrl() string {
	if o == nil || IsNil(o.Url) {
		var ret string
		return ret
	}
	return *o.Url
}

// GetUrlOk returns a tuple with the Url field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateConnectorFormAllOf) GetUrlOk() (*string, bool) {
	if o == nil || IsNil(o.Url) {
		return nil, false
	}
	return o.Url, true
}

// HasUrl returns a boolean if a field has been set.
func (o *TemplateConnectorFormAllOf) HasUrl() bool {
	if o != nil && !IsNil(o.Url) {
		return true
	}

	return false
}

// SetUrl gets a reference to the given string and assigns it to the Url field.
func (o *TemplateConnectorFormAllOf) SetUrl(v string) {
	o.Url = &v
}

// GetMethod returns the Method field value if set, zero value otherwise.
func (o *TemplateConnectorFormAllOf) GetMethod() string {
	if o == nil || IsNil(o.Method) {
		var ret string
		return ret
	}
	return *o.Method
}

// GetMethodOk returns a tuple with the Method field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateConnectorFormAllOf) GetMethodOk() (*string, bool) {
	if o == nil || IsNil(o.Method) {
		return nil, false
	}
	return o.Method, true
}

// HasMethod returns a boolean if a field has been set.
func (o *TemplateConnectorFormAllOf) HasMethod() bool {
	if o != nil && !IsNil(o.Method) {
		return true
	}

	return false
}

// SetMethod gets a reference to the given string and assigns it to the Method field.
func (o *TemplateConnectorFormAllOf) SetMethod(v string) {
	o.Method = &v
}

// GetHeaders returns the Headers field value if set, zero value otherwise.
func (o *TemplateConnectorFormAllOf) GetHeaders() []interface{} {
	if o == nil || IsNil(o.Headers) {
		var ret []interface{}
		return ret
	}
	return o.Headers
}

// GetHeadersOk returns a tuple with the Headers field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateConnectorFormAllOf) GetHeadersOk() ([]interface{}, bool) {
	if o == nil || IsNil(o.Headers) {
		return nil, false
	}
	return o.Headers, true
}

// HasHeaders returns a boolean if a field has been set.
func (o *TemplateConnectorFormAllOf) HasHeaders() bool {
	if o != nil && !IsNil(o.Headers) {
		return true
	}

	return false
}

// SetHeaders gets a reference to the given []interface{} and assigns it to the Headers field.
func (o *TemplateConnectorFormAllOf) SetHeaders(v []interface{}) {
	o.Headers = v
}

// GetBody returns the Body field value if set, zero value otherwise.
func (o *TemplateConnectorFormAllOf) GetBody() string {
	if o == nil || IsNil(o.Body) {
		var ret string
		return ret
	}
	return *o.Body
}

// GetBodyOk returns a tuple with the Body field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateConnectorFormAllOf) GetBodyOk() (*string, bool) {
	if o == nil || IsNil(o.Body) {
		return nil, false
	}
	return o.Body, true
}

// HasBody returns a boolean if a field has been set.
func (o *TemplateConnectorFormAllOf) HasBody() bool {
	if o != nil && !IsNil(o.Body) {
		return true
	}

	return false
}

// SetBody gets a reference to the given string and assigns it to the Body field.
func (o *TemplateConnectorFormAllOf) SetBody(v string) {
	o.Body = &v
}

// GetTransformation returns the Transformation field value if set, zero value otherwise.
func (o *TemplateConnectorFormAllOf) GetTransformation() string {
	if o == nil || IsNil(o.Transformation) {
		var ret string
		return ret
	}
	return *o.Transformation
}

// GetTransformationOk returns a tuple with the Transformation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateConnectorFormAllOf) GetTransformationOk() (*string, bool) {
	if o == nil || IsNil(o.Transformation) {
		return nil, false
	}
	return o.Transformation, true
}

// HasTransformation returns a boolean if a field has been set.
func (o *TemplateConnectorFormAllOf) HasTransformation() bool {
	if o != nil && !IsNil(o.Transformation) {
		return true
	}

	return false
}

// SetTransformation gets a reference to the given string and assigns it to the Transformation field.
func (o *TemplateConnectorFormAllOf) SetTransformation(v string) {
	o.Transformation = &v
}

// GetEmitter returns the Emitter field value if set, zero value otherwise.
func (o *TemplateConnectorFormAllOf) GetEmitter() string {
	if o == nil || IsNil(o.Emitter) {
		var ret string
		return ret
	}
	return *o.Emitter
}

// GetEmitterOk returns a tuple with the Emitter field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateConnectorFormAllOf) GetEmitterOk() (*string, bool) {
	if o == nil || IsNil(o.Emitter) {
		return nil, false
	}
	return o.Emitter, true
}

// HasEmitter returns a boolean if a field has been set.
func (o *TemplateConnectorFormAllOf) HasEmitter() bool {
	if o != nil && !IsNil(o.Emitter) {
		return true
	}

	return false
}

// SetEmitter gets a reference to the given string and assigns it to the Emitter field.
func (o *TemplateConnectorFormAllOf) SetEmitter(v string) {
	o.Emitter = &v
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *TemplateConnectorFormAllOf) GetOAuthId() string {
	if o == nil || IsNil(o.OAuthId) {
		var ret string
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateConnectorFormAllOf) GetOAuthIdOk() (*string, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *TemplateConnectorFormAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given string and assigns it to the OAuthId field.
func (o *TemplateConnectorFormAllOf) SetOAuthId(v string) {
	o.OAuthId = &v
}

// GetParameters returns the Parameters field value if set, zero value otherwise.
func (o *TemplateConnectorFormAllOf) GetParameters() []string {
	if o == nil || IsNil(o.Parameters) {
		var ret []string
		return ret
	}
	return o.Parameters
}

// GetParametersOk returns a tuple with the Parameters field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateConnectorFormAllOf) GetParametersOk() ([]string, bool) {
	if o == nil || IsNil(o.Parameters) {
		return nil, false
	}
	return o.Parameters, true
}

// HasParameters returns a boolean if a field has been set.
func (o *TemplateConnectorFormAllOf) HasParameters() bool {
	if o != nil && !IsNil(o.Parameters) {
		return true
	}

	return false
}

// SetParameters gets a reference to the given []string and assigns it to the Parameters field.
func (o *TemplateConnectorFormAllOf) SetParameters(v []string) {
	o.Parameters = v
}

// GetAttributes returns the Attributes field value if set, zero value otherwise.
func (o *TemplateConnectorFormAllOf) GetAttributes() []string {
	if o == nil || IsNil(o.Attributes) {
		var ret []string
		return ret
	}
	return o.Attributes
}

// GetAttributesOk returns a tuple with the Attributes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *TemplateConnectorFormAllOf) GetAttributesOk() ([]string, bool) {
	if o == nil || IsNil(o.Attributes) {
		return nil, false
	}
	return o.Attributes, true
}

// HasAttributes returns a boolean if a field has been set.
func (o *TemplateConnectorFormAllOf) HasAttributes() bool {
	if o != nil && !IsNil(o.Attributes) {
		return true
	}

	return false
}

// SetAttributes gets a reference to the given []string and assigns it to the Attributes field.
func (o *TemplateConnectorFormAllOf) SetAttributes(v []string) {
	o.Attributes = v
}

func (o TemplateConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TemplateConnectorFormAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Label) {
		toSerialize["label"] = o.Label
	}
	if !IsNil(o.Url) {
		toSerialize["url"] = o.Url
	}
	if !IsNil(o.Method) {
		toSerialize["method"] = o.Method
	}
	if !IsNil(o.Headers) {
		toSerialize["headers"] = o.Headers
	}
	if !IsNil(o.Body) {
		toSerialize["body"] = o.Body
	}
	if !IsNil(o.Transformation) {
		toSerialize["transformation"] = o.Transformation
	}
	if !IsNil(o.Emitter) {
		toSerialize["emitter"] = o.Emitter
	}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.Parameters) {
		toSerialize["parameters"] = o.Parameters
	}
	if !IsNil(o.Attributes) {
		toSerialize["attributes"] = o.Attributes
	}
	return toSerialize, nil
}

type NullableTemplateConnectorFormAllOf struct {
	value *TemplateConnectorFormAllOf
	isSet bool
}

func (v NullableTemplateConnectorFormAllOf) Get() *TemplateConnectorFormAllOf {
	return v.value
}

func (v *NullableTemplateConnectorFormAllOf) Set(val *TemplateConnectorFormAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableTemplateConnectorFormAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableTemplateConnectorFormAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTemplateConnectorFormAllOf(val *TemplateConnectorFormAllOf) *NullableTemplateConnectorFormAllOf {
	return &NullableTemplateConnectorFormAllOf{value: val, isSet: true}
}

func (v NullableTemplateConnectorFormAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTemplateConnectorFormAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
